# -*- coding: utf-8 -*-

import argparse
import sys


def str_type():
    try:
        return unicode
    except NameError:
        return str


def _get_action_name(argument):
    # This a backport of bugfix for bpo-29298
    # see: https://bugs.python.org/issue29298
    # was apparently fixed only for 3.9 in c589992e09
    if argument is None:
        return None
    elif argument.option_strings:
        return '/'.join(argument.option_strings)
    elif argument.metavar not in (None, argparse.SUPPRESS):
        return argument.metavar
    elif argument.dest not in (None, argparse.SUPPRESS):
        return argument.dest
    elif hasattr(argument, 'choices') and argument.choices:
        return '{' + ','.join(argument.choices) + '}'
    else:
        return None


def init():
    """Initialize all the necessary patches.  This must be run before
    any other code in the application anywhere."""
    # This is necessary to ensure consistent behavior in Python
    # versions prior to 3.9 where this function didn't check for
    # choices, but then would break internally when printing error
    # message about missing arguments.
    if sys.version_info[1] < 9:
        argparse._get_action_name = _get_action_name
